	var allocator 	= 0;
	var head 		= null;
	var tail 		= null;
	var entries 	= [];
	var allocated 	= [];
	var stack 		= 0;
	
	var objHead = new String('999999');
	var objTail = new String('999999');
	
	var drag = null;
	var dragColor;
	var overColor;
	
	function loadEntries () {
		for (var a in cookies) {
			addEntry(cookies[a]);
		}
	}

	function addEntry (entryName) {
		var tr;
		var td;
		var info;
		
		stack = stack + 1;
		createTableList();
		while (allocated[allocator] == 1) {
			allocator = allocator + 1;
		}
		
		entries[allocator] = new String(entryName);
		allocated[allocator] = 1;
		if (tail) {
			entries[allocator].prev = tail;
			entries[allocator].prev.next = entries[allocator];
			entries[allocator].next = objTail;
			objTail.prev = entries[allocator];
		} else {
			head = entries[allocator];
			entries[allocator].prev = objHead;
			objHead.next = entries[allocator];
			entries[allocator].next = objTail;
			objTail.prev = entries[allocator];
		}
		
		tail = entries[allocator];
		
		entries[allocator].i = allocator;
		entries[allocator].u = getCookie(entryName + '.u');
		entries[allocator].p = getCookie(entryName + '.p');
		
		entries[allocator].label = listNewRow();
		disableSelection(entries[allocator].label);
		td = newCell(entryName);
		
		td.style.cursor = 'crosshair';
		addLink(td, allocator); 
		//Can't get 'this' to work on IE, 'this' always returns 'undefined'
		//So, I've had to resort to a function call
		
		//addCookies
		refreshCookies(entries[allocator]);
	}
	
	function deleteEntry(num){
		if (head == entries[num]) {
			if (entries[num].next != objTail) {
				head = entries[num].next;
				objHead.next = entries[num].next;
				entries[num].next.prev = objHead;
			} else {
				head = null;
				objHead.next = objTail;
				objTail.prev = objHead;
			}
		}

		if (tail == entries[num]) {
			if (entries[num].prev != objHead) {
				tail = entries[num].prev;
				objTail.prev = entries[num].prev;
				entries[num].prev.next = objTail;
			} else {
				tail = null;
				objHead.next = objTail;
				objTail.prev = objHead;
			}
		}

		if (allocator > num) {
			allocator = num;
		}

		if (entries[num].next != objTail) {
			entries[num].next.prev = entries[num].prev;
		}
		
		if (entries[num].prev != objHead) {
			entries[num].prev.next = entries[num].next;
		}

		if (entries[num].next != objTail) {
			selectEntry(entries[num].next.i);
		} else if (entries[num].prev != objHead) {
			selectEntry(entries[num].prev.i);
		}
		
		allocated[num] = 0;
		stack = stack - 1;
		
		entries[num].label.parentNode.removeChild(entries[num].label);
		
		if (stack === 0) {
			deleteTableList();
			get('list').innerHTML = listHTML;
		}
		
		//deleteCookies
		refreshCookies(entries[num]);
	}

	function selectEntry (num) {
		var cur_node = head;
		
		get('display').innerHTML = '';
		get('display').appendChild(entries[num].table);
		while (cur_node != objTail) {
			cur_node.label.style.backgroundColor = '#ffffff';
			cur_node = cur_node.next;
		}
		entries[num].label.style.backgroundColor = '#99ccff';
	}

	function addLink (cell, num) {
		var aL_table = newElement('table', null);
		var aL_tbody = newElement('tbody', null);
		var aL_cell;
		var aL_button;
		var arr = [
			['<b>Entry Name:</b>',  entries[num]],
			['<b>Username:</b>', 	entries[num].u],
			['<b>Password:</b>', 	entries[num].p]
		];
		
		aL_table.appendChild(aL_tbody);
		entries[num].table = aL_table;
		
		for (var a in arr) {
			newRow(aL_tbody);
			newCell(arr[a][0]);
			newCell(arr[a][1]);
		}
		
		newRow(aL_tbody);
		aL_cell = newCell('');
		aL_cell.colspan = 2;
		aL_button = newElement('input', null);
		aL_button.type = 'button';
		aL_button.value = 'Delete Entry';
		addEvent(aL_button, 'click', function () {
			deleteEntry(num);
		});
		
		aL_cell.appendChild(aL_button);
		
		addEvent(cell, 'click', function () {
			selectEntry(num);
		});
		
		addEvent(cell, 'mousedown', function () {
			dragEntry(num);
		});
		
		addEvent(cell, 'mouseup', function () {
				dropEntry(num);
		});
		
		addEvent(cell, 'mouseover', function () {
			if (drag) {
				mouseOverEntry(num);
			}
		});
		
		addEvent(cell, 'mouseout', function () {
			if (drag) {
				mouseOutEntry(num);
			}
		});
	}
	
	function newEntry () {
		//All fields must be filled
		//Entry names must be unique
		//Symbols ; and , are not allowed
		var n = get('name').value;
		var u = get('username').value;
		var p = get('password').value;
		
		var cur_node = head;
		var unique = true;
		while (cur_node && unique == true) {
			if (cur_node == n) {
				unique = false;
			}
			cur_node = cur_node.next;
		}
		
		if (!n || !u || !p) {
			get('display').innerHTML = '<center><b>Error while adding entry: </b><br>The form must be completely filled.</center>';
		} else if (unique == false) {
			get('display').innerHTML = '<center><b>Error while adding entry: </b><br>Entry names must be unique.</center>';
		} else if ((n.search(';') > 0) || (n.search(',') > 0) || (u.search(';') > 0) || (u.search(',') > 0) || (p.search(';') > 0) || (p.search(',') > 0)) {
			get('display').innerHTML = '<center><b>Error while adding entry: </b><br>The symbols ; and , are not allowed in any of the fields.</center>';
		} else {
			//All tests passed..
			newCookie(n + '.u', u);
			newCookie(n + '.p', p);
			addEntry(n);
		}
	}

	function dragEntry (num) {
		drag = new Number(findQ(num));
		dragColor = entries[num].label.style.backgroundColor;
		entries[num].label.style.backgroundColor = '#006633';
		return false;
	}
	
	function dropEntry(num){
		var drop = findQ(num);
		var ind = findIndex(drag);
		var drag_prev = entries[ind].prev;
		var drag_next = entries[ind].next;

		if (drop != drag) {
			var cur_node = head;
			while (cur_node != objTail) {
				tableList.removeChild(cur_node.label);
				cur_node = cur_node.next;
			}
			//Re-arrange list;
			var arr = [
				[entries[ind].next, entries[num], entries[ind]], 
				[entries[ind].prev, entries[num], entries[ind]], 
				[entries[num].next, entries[ind], entries[num]], 
				[entries[num].prev, entries[ind], entries[num]]
			];
			
			for (var n in arr) {
				if (arr[n][0] == arr[n][1]) {
					arr[n][0] = arr[n][2];
				}
			}
			var drag_n = arr[0][0];
			var drag_p = arr[1][0];
			var drop_n = arr[2][0];
			var drop_p = arr[3][0];

			drag_n.prev = entries[num];
			drag_p.next = entries[num];

			drop_n.prev = entries[ind];
			drop_p.next = entries[ind];
			
			entries[ind].next = drop_n;
			entries[ind].prev = drop_p;

			entries[num].next = drag_n;
			entries[num].prev = drag_p;

			if (drag_n == objTail) {
				tail = entries[num];
			}
			
			if (drop_n == objTail) {
				tail = entries[ind];
			}
			if (drag_p == objHead) {
				head = entries[num];
			}
			if (drop_p == objHead) {
				head = entries[ind];
			}
			//RedrawTable
			cur_node = head;
			
			while (cur_node != objTail) {
				tableList.appendChild(cur_node.label);
				cur_node = cur_node.next;
			}
			entries[ind].label.style.backgroundColor = dragColor;
		}
		
		drag = null;
		entries[num].label.style.backgroundColor = overColor;
		refreshCookies();
	}
	
	function mouseOverEntry (num) {
		if (findIndex(drag) != num && drag) {
			overColor = entries[num].label.style.backgroundColor;
			entries[num].label.style.backgroundColor = '#99ff33';
		}
	}
	
	function mouseOutEntry (num) {
		if (findIndex(drag) != num && drag) {
			entries[num].label.style.backgroundColor = overColor;
		}
	}
	
	function findQ (num) {
		var cur_node = head;
		var Q = 0;
		while ((cur_node != entries[num]) && cur_node) {
			Q = Q + 1;
			cur_node =cur_node.next;
		}
		return Q;
	}
	
	function findIndex (num) {
		var cur_node = head;
		var Q = 0;
		while (cur_node && (Q != num)) {
			Q = Q + 1;
			cur_node =cur_node.next;
		}
		return cur_node.i;		
	}

	function listCheck () {
		var cur_node = head;
		var loop = 0; //In case a bug causes the list to break.
		var string = 'forward in the list: ';
		while ((cur_node != objTail) && (loop < stack + 10)) {
			string = string + cur_node + ',';
			cur_node = cur_node.next;
			loop = loop + 1;
		}
		debug(string);
		if (loop > stack) {
			debug('The list is broken.<br>Direction:Next');
		}
		
		cur_node = tail;
		loop = 0;
		string = 'backward in the list: ';
		while ((cur_node != objHead) && (loop < stack + 10)) {
			string = string + cur_node + ',';
			cur_node = cur_node.prev;
			loop = loop + 1;
		}
		debug(string);
		if (loop > stack) {
			debug('The list is broken.<br>Direction:Prev');
		}
		
			
	}
